Index: /trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UIDetailsWidgetNATNetwork.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UIDetailsWidgetNATNetwork.cpp	(revision 87564)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UIDetailsWidgetNATNetwork.cpp	(revision 87565)
@@ -43,5 +43,4 @@
     , m_enmEmbedding(enmEmbedding)
     , m_pTabWidget(0)
-    , m_pCheckboxNetworkAvailable(0)
     , m_pLabelNetworkName(0)
     , m_pEditorNetworkName(0)
@@ -118,6 +117,5 @@
 {
 //    if (m_oldData != m_newData)
-//        printf("Network: %d, %s, %s, %s, %d, %d, %d\n",
-//               m_newData.m_fEnabled,
+//        printf("Network: %s, %s, %s, %d, %d, %d\n",
 //               m_newData.m_strName.toUtf8().constData(),
 //               m_newData.m_strPrefixIPv4.toUtf8().constData(),
@@ -152,10 +150,4 @@
     }
 
-    /* Translate 'Options' tab content: */
-    if (m_pCheckboxNetworkAvailable)
-    {
-        m_pCheckboxNetworkAvailable->setText(tr("&Enable Network"));
-        m_pCheckboxNetworkAvailable->setToolTip(tr("When checked, this network will be enabled."));
-    }
     if (m_pLabelNetworkName)
         m_pLabelNetworkName->setText(tr("&Name:"));
@@ -222,11 +214,4 @@
 }
 
-void UIDetailsWidgetNATNetwork::sltNetworkAvailabilityChanged(bool fChecked)
-{
-    m_newData.m_fEnabled = fChecked;
-    loadDataForOptions();
-    updateButtonStates();
-}
-
 void UIDetailsWidgetNATNetwork::sltNetworkNameChanged(const QString &strText)
 {
@@ -348,5 +333,5 @@
     {
         /* Prepare 'Options' layout: */
-        QGridLayout *pLayoutOptions = new QGridLayout(pTabOptions);
+        QVBoxLayout *pLayoutOptions = new QVBoxLayout(pTabOptions);
         if (pLayoutOptions)
         {
@@ -356,18 +341,4 @@
 #endif
 
-            /* Prepare network availability check-box: */
-            m_pCheckboxNetworkAvailable = new QCheckBox(pTabOptions);
-            if (m_pCheckboxNetworkAvailable)
-            {
-                connect(m_pCheckboxNetworkAvailable, &QCheckBox::toggled,
-                        this, &UIDetailsWidgetNATNetwork::sltNetworkAvailabilityChanged);
-                pLayoutOptions->addWidget(m_pCheckboxNetworkAvailable, 0, 0, 1, 2);
-            }
-
-            /* Prepare 20-px shifting spacer: */
-            QSpacerItem *pSpacerItem = new QSpacerItem(20, 0, QSizePolicy::Fixed, QSizePolicy::Minimum);
-            if (pSpacerItem)
-                pLayoutOptions->addItem(pSpacerItem, 1, 0);
-
             /* Prepare settings widget layout: */
             QGridLayout *pLayoutSettings = new QGridLayout;
@@ -466,5 +437,5 @@
                 }
 
-                pLayoutOptions->addLayout(pLayoutSettings, 1, 1);
+                pLayoutOptions->addLayout(pLayoutSettings);
             }
 
@@ -479,5 +450,5 @@
                     connect(m_pButtonBoxOptions, &QIDialogButtonBox::clicked, this, &UIDetailsWidgetNATNetwork::sltHandleButtonBoxClick);
 
-                    pLayoutOptions->addWidget(m_pButtonBoxOptions, 2, 0, 1, 2);
+                    pLayoutOptions->addWidget(m_pButtonBoxOptions);
                 }
             }
@@ -555,21 +526,18 @@
     /* Check whether network exists and enabled: */
     const bool fIsNetworkExists = m_newData.m_fExists;
-    const bool fIsNetworkEnabled = m_newData.m_fEnabled;
 
     /* Update 'Options' field availability: */
-    m_pCheckboxNetworkAvailable->setEnabled(fIsNetworkExists);
-    m_pLabelNetworkName->setEnabled(fIsNetworkExists && fIsNetworkEnabled);
-    m_pEditorNetworkName->setEnabled(fIsNetworkExists && fIsNetworkEnabled);
-    m_pLabelNetworkIPv4Prefix->setEnabled(fIsNetworkExists && fIsNetworkEnabled);
-    m_pEditorNetworkIPv4Prefix->setEnabled(fIsNetworkExists && fIsNetworkEnabled);
-    m_pLabelNetworkIPv6Prefix->setEnabled(fIsNetworkExists && fIsNetworkEnabled);
-    m_pEditorNetworkIPv6Prefix->setEnabled(fIsNetworkExists && fIsNetworkEnabled);
-    m_pLabelExtended->setEnabled(fIsNetworkExists && fIsNetworkEnabled);
-    m_pCheckboxSupportsDHCP->setEnabled(fIsNetworkExists && fIsNetworkEnabled);
-    m_pCheckboxSupportsIPv6->setEnabled(fIsNetworkExists && fIsNetworkEnabled);
-    m_pCheckboxAdvertiseDefaultIPv6Route->setEnabled(fIsNetworkExists && fIsNetworkEnabled);
+    m_pLabelNetworkName->setEnabled(fIsNetworkExists);
+    m_pEditorNetworkName->setEnabled(fIsNetworkExists);
+    m_pLabelNetworkIPv4Prefix->setEnabled(fIsNetworkExists);
+    m_pEditorNetworkIPv4Prefix->setEnabled(fIsNetworkExists);
+    m_pLabelNetworkIPv6Prefix->setEnabled(fIsNetworkExists);
+    m_pEditorNetworkIPv6Prefix->setEnabled(fIsNetworkExists);
+    m_pLabelExtended->setEnabled(fIsNetworkExists);
+    m_pCheckboxSupportsDHCP->setEnabled(fIsNetworkExists);
+    m_pCheckboxSupportsIPv6->setEnabled(fIsNetworkExists);
+    m_pCheckboxAdvertiseDefaultIPv6Route->setEnabled(fIsNetworkExists);
 
     /* Load 'Options' fields: */
-    m_pCheckboxNetworkAvailable->setChecked(fIsNetworkEnabled);
     m_pEditorNetworkName->setText(m_newData.m_strName);
     m_pEditorNetworkIPv4Prefix->setText(m_newData.m_strPrefixIPv4);
@@ -584,9 +552,8 @@
     /* Check whether network exists and enabled: */
     const bool fIsNetworkExists = m_newData.m_fExists;
-    const bool fIsNetworkEnabled = m_newData.m_fEnabled;
 
     /* Update 'Forwarding' field availability: */
-    m_pForwardingTableIPv4->setEnabled(fIsNetworkExists && fIsNetworkEnabled);
-    m_pForwardingTableIPv6->setEnabled(fIsNetworkExists && fIsNetworkEnabled);
+    m_pForwardingTableIPv4->setEnabled(fIsNetworkExists);
+    m_pForwardingTableIPv6->setEnabled(fIsNetworkExists);
 
     /* Calculate/load guest address hints: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UIDetailsWidgetNATNetwork.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UIDetailsWidgetNATNetwork.h	(revision 87564)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UIDetailsWidgetNATNetwork.h	(revision 87565)
@@ -47,5 +47,4 @@
     UIDataNATNetwork()
         : m_fExists(false)
-        , m_fEnabled(false)
         , m_strName(QString())
         , m_strPrefixIPv4(QString())
@@ -61,5 +60,4 @@
         return true
                && (m_fExists == other.m_fExists)
-               && (m_fEnabled == other.m_fEnabled)
                && (m_strName == other.m_strName)
                && (m_strPrefixIPv4 == other.m_strPrefixIPv4)
@@ -80,6 +78,4 @@
     /** Holds whether this network is not NULL. */
     bool                      m_fExists;
-    /** Holds whether this network enabled. */
-    bool                      m_fEnabled;
     /** Holds network name. */
     QString                   m_strName;
@@ -151,6 +147,4 @@
     /** @name Change handling stuff.
       * @{ */
-        /** Handles network availability choice change. */
-        void sltNetworkAvailabilityChanged(bool fChecked);
         /** Handles network name text change. */
         void sltNetworkNameChanged(const QString &strText);
@@ -215,6 +209,4 @@
     /** @name Network variables.
       * @{ */
-        /** Holds the network availability check-box instance. */
-        QCheckBox         *m_pCheckboxNetworkAvailable;
         /** Holds the network name label instance. */
         QLabel            *m_pLabelNetworkName;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UINetworkManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UINetworkManager.cpp	(revision 87564)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UINetworkManager.cpp	(revision 87565)
@@ -73,5 +73,4 @@
 enum NATNetworkColumn
 {
-    NATNetworkColumn_Availability,
     NATNetworkColumn_Name,
     NATNetworkColumn_Max,
@@ -233,5 +232,4 @@
 {
     /* Compose item fields: */
-    setCheckState(NATNetworkColumn_Availability, m_fEnabled ? Qt::Checked : Qt::Unchecked);
     setText(NATNetworkColumn_Name, m_strName);
 
@@ -257,7 +255,5 @@
 QString UIItemNATNetwork::defaultText() const
 {
-    return   m_fEnabled
-           ? tr("%1, %2", "col.2 text, col.1 name").arg(text(1)).arg(parentTree()->headerItem()->text(0))
-           : tr("%1",     "col.2 text").arg(text(1));
+    return tr("%1, %2", "col.2 text, col.1 name").arg(text(1)).arg(parentTree()->headerItem()->text(0));
 }
 
@@ -328,5 +324,4 @@
     {
         const QStringList fields = QStringList()
-                                   << UINetworkManager::tr("Active")
                                    << UINetworkManager::tr("Name");
         m_pTreeWidgetNATNetwork->setHeaderLabels(fields);
@@ -556,5 +551,4 @@
     UIDataNATNetwork oldData;
     oldData.m_fExists = true;
-    oldData.m_fEnabled = true;
     oldData.m_strName = strNetworkName;
     oldData.m_strPrefixIPv4 = "10.0.2.0/24";
@@ -575,7 +569,4 @@
     else
     {
-        /* Save whether NAT network is enabled: */
-        if (comNetwork.isOk())
-            comNetwork.SetEnabled(oldData.m_fEnabled);
         /* Save NAT network name: */
         if (comNetwork.isOk())
@@ -739,4 +730,5 @@
     }
 
+#if 0
     /* Check NAT network tree-widget: */
     if (m_pTreeWidgetNATNetwork)
@@ -757,4 +749,5 @@
         m_pTreeWidgetNATNetwork->setColumnWidth(NATNetworkColumn_Name, iTotal - iWidth1);
     }
+#endif
 }
 
@@ -1020,54 +1013,4 @@
 }
 
-void UINetworkManagerWidget::sltHandleItemChangeNATNetwork(QTreeWidgetItem *pItem)
-{
-    /* Get network item: */
-    UIItemNATNetwork *pChangedItem = static_cast<UIItemNATNetwork*>(pItem);
-    AssertMsgReturnVoid(pChangedItem, ("Changed item must not be null!\n"));
-
-    /* Get item data: */
-    UIDataNATNetwork oldData = *pChangedItem;
-
-    /* Make sure network availability status changed: */
-    if (   (   oldData.m_fEnabled
-            && pChangedItem->checkState(NATNetworkColumn_Availability) == Qt::Checked)
-        || (   !oldData.m_fEnabled
-            && pChangedItem->checkState(NATNetworkColumn_Availability) == Qt::Unchecked))
-        return;
-
-    /* Get VirtualBox for further activities: */
-    CVirtualBox comVBox = uiCommon().virtualBox();
-
-    /* Find corresponding network: */
-    CNATNetwork comNetwork = comVBox.FindNATNetworkByName(oldData.m_strName);
-
-    /* Show error message if necessary: */
-    if (!comVBox.isOk() || comNetwork.isNull())
-        msgCenter().cannotFindNATNetwork(comVBox, oldData.m_strName, this);
-    else
-    {
-        /* Save whether NAT network is enabled: */
-        if (comNetwork.isOk())
-            comNetwork.SetEnabled(!oldData.m_fEnabled);
-
-        /* Show error message if necessary: */
-        if (!comNetwork.isOk())
-            msgCenter().cannotSaveNATNetworkParameter(comNetwork, this);
-        else
-        {
-            /* Update network in the tree: */
-            UIDataNATNetwork data;
-            loadNATNetwork(comNetwork, data);
-            updateItemForNATNetwork(data, true, pChangedItem);
-
-            /* Make sure current item fetched, trying to hold chosen position: */
-            sltHandleCurrentItemChangeNATNetworkHoldingPosition(true /* hold position? */);
-
-            /* Adjust tree-widgets: */
-            sltAdjustTreeWidgets();
-        }
-    }
-}
-
 void UINetworkManagerWidget::sltHandleCurrentItemChangeNATNetworkHoldingPosition(bool fHoldPosition)
 {
@@ -1152,7 +1095,4 @@
         else
         {
-            /* Save whether NAT network is enabled: */
-            if (comNetwork.isOk() && newData.m_fEnabled != oldData.m_fEnabled)
-                comNetwork.SetEnabled(newData.m_fEnabled);
             /* Save NAT network name: */
             if (comNetwork.isOk() && newData.m_strName != oldData.m_strName)
@@ -1451,6 +1391,4 @@
         connect(m_pTreeWidgetNATNetwork, &QITreeWidget::customContextMenuRequested,
                 this, &UINetworkManagerWidget::sltHandleContextMenuRequestNATNetwork);
-        connect(m_pTreeWidgetNATNetwork, &QITreeWidget::itemChanged,
-                this, &UINetworkManagerWidget::sltHandleItemChangeNATNetwork);
         connect(m_pTreeWidgetNATNetwork, &QITreeWidget::itemDoubleClicked,
                 m_pActionPool->action(UIActionIndexMN_M_Network_T_Details), &QAction::setChecked);
@@ -1631,6 +1569,4 @@
     if (comNetwork.isNotNull())
         data.m_fExists = true;
-    if (comNetwork.isOk())
-        data.m_fEnabled = comNetwork.GetEnabled();
     if (comNetwork.isOk())
         data.m_strName = comNetwork.GetNetworkName();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UINetworkManager.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UINetworkManager.h	(revision 87564)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UINetworkManager.h	(revision 87565)
@@ -140,6 +140,4 @@
         void sltApplyDetailsChangesHostNetwork();
 
-        /** Handles NAT network tree-widget @a pItem change. */
-        void sltHandleItemChangeNATNetwork(QTreeWidgetItem *pItem);
         /** Handles NAT network tree-widget current item change.
           * @param  fHoldPosition  Holds whether we should try to keep